Package org.optaplanner.core.impl.score.buildin.hardsoftbigdecimal

## Class HardSoftBigDecimalScoreDefinition

- java.lang.Object
- - org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<HardSoftBigDecimalScore>
  - - org.optaplanner.core.impl.score.buildin.hardsoftbigdecimal.HardSoftBigDecimalScoreDefinition

- All Implemented Interfaces:
    `Serializable`, `ScoreDefinition<HardSoftBigDecimalScore>`

      public class HardSoftBigDecimalScoreDefinition
      extends AbstractScoreDefinition<HardSoftBigDecimalScore>

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HardSoftBigDecimalScoreDefinition()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HardSoftBigDecimalScore` | `buildOptimisticBound​(InitializingScoreTrend initializingScoreTrend, HardSoftBigDecimalScore score)` | Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
    `HardSoftBigDecimalScore` | `buildPessimisticBound​(InitializingScoreTrend initializingScoreTrend, HardSoftBigDecimalScore score)` | Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
    `ScoreHolder` | `buildScoreHolder​(boolean constraintMatchEnabled)` | Used by `DroolsScoreDirector`.
    `HardSoftBigDecimalScoreInliner` | `buildScoreInliner​(boolean constraintMatchEnabled)` | Used by `BavetConstraintFactory`
    `HardSoftBigDecimalScore` | `divideBySanitizedDivisor​(HardSoftBigDecimalScore dividend, HardSoftBigDecimalScore divisor)` | Return `Score` whose every level is the result of dividing the matching levels in this and the divisor.
    `HardSoftBigDecimalScore` | `fromLevelNumbers​(int initScore, Number[] levelNumbers)` | The opposite of `Score.toLevelNumbers()`.
    `int` | `getFeasibleLevelsSize()` | Returns the number of levels of `Score.toLevelNumbers()`.
    `int` | `getLevelsSize()` | Returns the length of `Score.toLevelNumbers()` for every `Score` of this definition.
    `HardSoftBigDecimalScore` | `getOneSoftestScore()` | The score that represents the softest possible one.
    `Class<HardSoftBigDecimalScore>` | `getScoreClass()` | Returns the `Class` of the actual `Score` implementation.
    `HardSoftBigDecimalScore` | `getZeroScore()` | The score that represents zero.
    `HardSoftBigDecimalScore` | `parseScore​(String scoreString)` | Parses the `String` and returns a `Score`.

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition

      `divide, divide, divide, divide, formatScore, getInitLabel, getLevelLabels, isCompatibleArithmeticArgument, sanitize, sanitize, sanitize, sanitize, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.definition.ScoreDefinition

      `isNegativeOrZero, isPositiveOrZero`

- - ### Constructor Detail

    - #### HardSoftBigDecimalScoreDefinition

          public HardSoftBigDecimalScoreDefinition()

  - ### Method Detail

    - #### getLevelsSize

          public int getLevelsSize()

      Description copied from interface: `ScoreDefinition`
      Returns the length of `Score.toLevelNumbers()` for every `Score` of this definition. For example: returns 2 on `HardSoftScoreDefinition`.
      Specified by:
        `getLevelsSize` in interface `ScoreDefinition<HardSoftBigDecimalScore>`
      Overrides:
        `getLevelsSize` in class `AbstractScoreDefinition<HardSoftBigDecimalScore>`
      Returns:
        at least 1

    - #### getFeasibleLevelsSize

          public int getFeasibleLevelsSize()

      Description copied from interface: `ScoreDefinition`
      Returns the number of levels of `Score.toLevelNumbers()`. that are used to determine `Score.isFeasible()`.
      Returns:
        at least 0, at most `ScoreDefinition.getLevelsSize()`

    - #### getScoreClass

          public Class<HardSoftBigDecimalScore> getScoreClass()

      Description copied from interface: `ScoreDefinition`
      Returns the `Class` of the actual `Score` implementation. For example: returns `HardSoftScore.class` on `HardSoftScoreDefinition`.
      Returns:
        never null

    - #### getZeroScore

          public HardSoftBigDecimalScore getZeroScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents zero.
      Returns:
        never null

    - #### getOneSoftestScore

          public HardSoftBigDecimalScore getOneSoftestScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents the softest possible one.
      Returns:
        never null

    - #### parseScore

          public HardSoftBigDecimalScore parseScore​(String scoreString)

      Description copied from interface: `ScoreDefinition`
      Parses the `String` and returns a `Score`.
      Parameters:
        `scoreString` - never null
      Returns:
        never null
      See Also:
        `ScoreDefinition.formatScore(Score)`, `ScoreUtils.parseScore(Class, String)`

    - #### fromLevelNumbers

          public HardSoftBigDecimalScore fromLevelNumbers​(int initScore,
                                                          Number[] levelNumbers)

      Description copied from interface: `ScoreDefinition`
      The opposite of `Score.toLevelNumbers()`.
      Parameters:
        `initScore` - `<= 0`, managed by OptaPlanner, needed as a parameter in the `Score`'s creation method, see `Score.getInitScore()`
        `levelNumbers` - never null
      Returns:
        never null

    - #### buildScoreInliner

          public HardSoftBigDecimalScoreInliner buildScoreInliner​(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `BavetConstraintFactory`
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildScoreHolder

          public ScoreHolder buildScoreHolder​(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `DroolsScoreDirector`.
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildOptimisticBound

          public HardSoftBigDecimalScore buildOptimisticBound​(InitializingScoreTrend initializingScoreTrend,
                                                              HardSoftBigDecimalScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`.
      Returns:
        never null

    - #### buildPessimisticBound

          public HardSoftBigDecimalScore buildPessimisticBound​(InitializingScoreTrend initializingScoreTrend,
                                                               HardSoftBigDecimalScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`
      Returns:
        never null

    - #### divideBySanitizedDivisor

          public HardSoftBigDecimalScore divideBySanitizedDivisor​(HardSoftBigDecimalScore dividend,
                                                                  HardSoftBigDecimalScore divisor)

      Description copied from interface: `ScoreDefinition`
      Return `Score` whose every level is the result of dividing the matching levels in this and the divisor. When rounding is needed, it is floored (as defined by `Math.floor(double)`).

      If any of the levels in the divisor are equal to zero, the method behaves as if they were equal to one instead.

        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor